package MonitorReport;
require CMONOS::Accestat::Accestat;
@ISA = qw(Accestat);
use strict;
######################################################################
# ˬԤΥ˥Ķ⥸塼
# MonitorReport.pm ver1.0
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 
######################################################################
# 
# 	$$data[0]	֡hhmmss
# 	$$data[1]	IPREMOTE_HOST
# 	$$data[2]	ե
# 	$$data[3]	饤ȴĶHTTP_USER_AGENT
# 	$$data[4]	饤ȼHTTP_ACCEPT_LANGUAGE
# 	$$data[5]	󥯸HTTP_REFERER
# 	$$data[6]	ɥ¦
# 	$$data[7]	ɥ¦ι⤵
# 	$$data[8]	꡼
# 	$$data[9]	꡼⤵
sub log_stat ($$$) {
my($this,$date,$data) = @_;

# ǡǽ
return 0 if (!$$data[6] || !$$data[7]) && (!$$data[8] || !$$data[9]);
my($platform);

if ($$data[3] =~ /Win/) {
	$platform = 'Windows';
} elsif ($$data[3] =~ /Mac/) {
	$platform = 'Macintosh';
} elsif ($$data[3] =~ /X\d{2}/) {
	$platform = 'UNIX';
} else {
	return 0;
}

if (!$this->{'is_counted'}{$$data[1] . $$data[3]}) {

	# ɥ
	if ($$data[6] > 0 && $$data[7] > 0) {
		$this->{'window_count'}->{$platform}++;
		$this->{'window_innerWidth'}->{$platform} += $$data[6];
		$this->{'window_innerHeight'}->{$platform} += $$data[7];
	}

	# ꡼󥵥
	if ($$data[8] > 0 && $$data[9] > 0) {
		$this->{'screen_count'}->{$platform}++;
		$this->{'screen_width'}->{$platform} += $$data[8];
		$this->{'screen_height'}->{$platform} += $$data[9];
		$this->{'screen_size'}->{$$data[8] . '' . $$data[9]}++;
	}

	# 粽Ψ
	if ($$data[6] > 0 && $$data[8] > 0) {
		$this->{'both_count'}->{$platform}++;
		$this->{'window_maximized'}->{$platform}++ if $$data[8] - $$data[6] < 50;
	}
	$this->{'is_counted'}{$$data[1] . $$data[3]} = 1;
}

return 1;
}

######################################################################
# ϥȥ
sub stat_title ($) {
my $this = shift;
return 'ˬԤΥ˥Ķ';
}

######################################################################
# Ϸɽ
sub print_report ($) {
#no warnings qw(numeric);
my $this = shift;
undef %{$this->{'is_counted'}};
delete $this->{'is_counted'};
return if defined $this->{'noLog'} && $this->{'noLog'};
my(@order);

# ɥ/꡼󥵥ʿͽ
my(%screen_size,%window_size,%graf_size);
$this->screen_average($this->{'screen_count'},$this->{'screen_width'},$this->{'screen_height'},0,\%screen_size,\%graf_size);
$this->screen_average($this->{'window_count'},$this->{'window_innerWidth'},$this->{'window_innerHeight'},1,\%window_size,\%graf_size);

@order = (' (꡼)','Windows (꡼)','Macintosh (꡼)','UNIX (꡼)');
$this->print_stat_report(
	'ʿѥ꡼󥵥',
	\@order,
	\%screen_size,
	\%window_size,
	\%graf_size,
	((!ref $this->{'screen_width'}) ? '' : $graf_size{$this->maximum(\%screen_size)}),
	'',
	'',
	'桼Ķ',
	'center',
	200,
	'ʿѥ',
	100,
	'ԥ[]'
);

# 粽Ψ
my(%window_maximized,$total_count,$total_maximized);
foreach (keys %{$this->{'both_count'}}) {
	$total_count += $this->{'both_count'}->{$_};
	$total_maximized += $this->{'window_maximized'}->{$_};

	$window_maximized{$_} = ($this->{'both_count'}->{$_}) ? int(($this->{'window_maximized'}->{$_} / $this->{'both_count'}->{$_}) * 10000) / 100 : 0;
}
$window_maximized{''} = ($total_count) ? int(($total_maximized / $total_count) * 10000) / 100 : 0;


@order = ('','Windows','Macintosh','UNIX');
$this->print_stat_report(
	'ɥ粽Ψ',
	\@order,
	\%window_maximized,
	'',
	'',
	100,
	'',
	'',
	'桼Ķ',
	'center',
	200,
	'粽Ψ (%)',
	100,
	'%'
);

# ꡼󥵥ʬ
@order = sort {$a <=> $b || $a cmp $b} keys %{$this->{'screen_size'}};
$this->print_stat_report(
	'꡼󥵥ʬ',
	\@order,
	$this->{'screen_size'},
	'',
	'',
	((!%{$this->{'screen_size'}}) ? '' : $this->{'screen_size'}->{$this->maximum($this->{'screen_size'})}),
	'',
	'',
	'꡼󥵥',
	'center',
	200,
	'',
	100,
	''
);

}

sub screen_average ($$$$$$$) {
my($this,$count,$width,$height,$window,$average,$graf) = @_;
my($platform,$w,$h,$total_count,$total_height,$total_width);
while (($platform,$w) = each %$width) {
	$w = ($$count{$platform}) ? int($w / $$count{$platform}) : 0;
	$h = ($$count{$platform}) ? int($$height{$platform} / $$count{$platform}) : 0;
	if (defined $window && $window) {
		$$average{$platform . ' (꡼)'}{$platform . ' (ɥ¦)'} = $w . '' . $h;
		$$graf{$platform . ' (ɥ¦)'} = $w * $h;
	} else {
		$$average{$platform . ' (꡼)'} = $w . '' . $h;
		$$graf{$platform . ' (꡼)'} = $w * $h;
	}

	$total_count += $$count{$platform};
	$total_width += $$width{$platform};
	$total_height += $$height{$platform};
}

$w = ($total_count) ? int($total_width / $total_count) : 0;
$h = ($total_count) ? int($total_height / $total_count) : 0;
if (defined $window && $window) {
	$$average{' (꡼)'}{' (ɥ¦)'} = $w . '' . $h;
	$$graf{' (ɥ¦)'} = $w * $h;
} else {
	$$average{' (꡼)'} = $w . '' . $h;
	$$graf{' (꡼)'} = $w * $h;
}
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {

	#ǥեȥ
	$main::k = 'monitor' if !defined $main::k || !$main::k;

	#饹Ͽ
	Common::class_register('monitor','MonitorReport');

}


1;

