package ProgressBar;
use strict;
######################################################################
# ץ쥹С⥸塼
# ProgressBar.pm 1.0
# Copyright (C) 2007-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-05-07
######################################################################
sub new ($;@) {
my $pkg = shift;
my $this = {};
bless $this;
$this;
}

sub css ($;$) {
my($this,$width) = @_;
$width = 1 if !$width;
return <<CSS
html,body{ height: 100%; }
div#progress-bar-box-bg {
  width: 100%;
  height: 100%;
  position: fixed !important;
  position: absolute;
  top: 0;
  left: 0;
  background-color: #000;
  z-index: 100;
  opacity: 0.7;
  -moz-opacity: 0.7;
  -webkit-opacity: 0.7;
  -o-opacity: 0.7;
  -ms-filter:"alpha(opacity=70)";
  filter:alpha(opacity=70);
}
div#progress-bar-box {
  width: 100%;
  height: 100%;
  position: fixed !important;
  position: absolute;
  top: 0;
  left: 0;
  z-index: 101;
  color: #FFF;
  text-align: center;
}
div#progress-bar-dialog {
  text-align: left;
  padding-top: 200px;
  width: 482px;
  margin: 0 auto;
}
div#progress-bar-bg {
  text-align: left;
  width: 480px;
  height: 24px;
  margin: 0 auto;
  background-color: rgba(0, 0, 0, 0.5) !important;
  background-color: transparent;
  border: 1px #CCC solid;
}
div#progress-bar {
  width: ${width}px;
  height: 24px;
  margin: 0;
  background-color: #69F;
  border: none;
}
CSS
}

sub print_progress_bar ($$;$) {
my($this,$name,$total) = @_;
print '<div id="progress-bar-box-bg"></div><div id="progress-bar-box"><div id="progress-bar-dialog"><span id="progress-bar-count"></span>/<span id="progress-bar-total">' . (($total) ? $total : '') . '</span> ' . (($name) ? $name : '') . ' <span id="time-remain">(ΤޤޤФ餯Ԥ)</span></div><div id="progress-bar-bg"><div id="progress-bar"></div></div></div>';
}

sub remove ($) {
my $this = shift;
print '<style type="text/css">div#progress-bar-box-bg, div#progress-bar-box { display: none; }</style>';
}

sub javascript ($$$) {
my $this = shift;
return <<'JAVASCRIPT'
cmonos.progressbar = {
	start : (new Date()).getTime(),
	update : function (count,total) {
		if (typeof document.body.style.maxHeight == "undefined") {
			document.getElementById('progress-bar-box-bg').style.height = (document.body.scrollTop + document.body.clientHeight) + 'px';
			document.getElementById('progress-bar-box-bg').style.width = (document.body.scrollLeft + document.body.clientWidth) + 'px';
		}
		document.getElementById('progress-bar-count').innerHTML = count;
		document.getElementById('progress-bar-total').innerHTML = total;
		if (count == total) {
			document.getElementById('progress-bar').style.width = '480px';
			document.getElementById('time-remain').innerHTML = '[λ]';
			document.getElementById('progress-bar-box-bg').style.display = 'none';
			document.getElementById('progress-bar-box').style.display = 'none';
		} else {
			var w = Math.floor(count / total * 480);
			document.getElementById('progress-bar').style.width = ((w > 0) ? w : 1) + 'px';
			if (count > 0) {
				var rmin = Math.ceil(((new Date()).getTime() - this.start) * (total - count) / count / 60000);
				document.getElementById('time-remain').innerHTML = ' [' + rmin + 'ʬ]';
			}
		}
	}
};
JAVASCRIPT
}

sub update ($$$;$$) {
my($this,$count,$total,$step,$script) = @_;
return 0 if $step && $this->{'prev'} && $count > $this->{'prev'} && $count < ($this->{'prev'} + ($total / $step)) && $count < $total;
$count = $total if $count > $total;
my $is_xhtml = (($default::doctype && $default::doctype =~ /XHTML/) || (!$default::doctype && $env::doctype && $env::doctype =~ /XHTML/)) ? 1 : 0;
print '<script type="text/javascript" language="JavaScript">' . "\x0A" . '<!--' . (($is_xhtml) ? ' <![CDATA[' : '') . "\x0A" . 'cmonos.progressbar.update(' . $count . ',' . $total . ');' . (($script) ? $script : '') . "\x0A" . '// ' . (($is_xhtml) ? ']]> ' : '') . '-->' . "\x0A" . '</script>'
		. '<noscript><style type="text/css">div#progress-bar { width: ' . int($count/$total*480) . 'px; }</style></noscript>';
$this->{'prev'} = $count;
return 1;
}

sub set_sig ($) {
my $this = shift;
$SIG{'INT'} = $SIG{'HUP'} = $SIG{'QUIT'} = $SIG{'TERM'} = sub {
print <<JAVASCRIPT;
<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
document.getElementById('progress-bar-box-bg').style.display = 'none';
document.getElementById('progress-bar-box').style.display = 'none';
alert('Ǥޤ');
// ]]> -->
</script>
JAVASCRIPT
exit;
};
}

1;