package Session;
use Fcntl qw(:flock);
use strict;
######################################################################
# å⥸塼
# Session.pm 1.9.1
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
#
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2009-11-16
######################################################################
# 
# Υ֥롼󽸤λȤ
# ---------------------------------------------------------------------------------------
#	(0) ֥Ȥ롣
#		require CMONOS::CGI_Lib::Session;
#		obj = Session->new(store,security,lifetime);
#			store			åǼǥ쥯ȥ
#			security		åϥåɻ
#									ip=ǧڻƱIPǤʤѥɤƳǧ
#									agent=ǧڻƱ쥨ȤǤʤѥɤƳǧ
#			lifetime		å¸֡
# 
# ---------------------------------------------------------------------------------------
#	(1) obj->is_available(id);
#		id ¸ߤ뤫åޤ¸ߤ 1 ֤ޤ
# 
# ---------------------------------------------------------------------------------------
#	(2) (email,pswd) = obj->get_user_info(id);
#		id ˥桼ǧھ󤬴ޤޤƤС֤ޤ
# 
# ---------------------------------------------------------------------------------------
#	(3) id = obj->mk_session_id;
#		åIDޤ
# 
# ---------------------------------------------------------------------------------------
#	(4) id = obj->set_user_info(email,pswd,id);
#		桼Ͽޤ
# 
# ---------------------------------------------------------------------------------------
#	(5) obj->erase(id);
#		åޤ
# 
# ---------------------------------------------------------------------------------------
#	(6) obj->gc;
#		¸֤᤮åޤ
# 
# ---------------------------------------------------------------------------------------
#	(7)-1 obj->save_by_uri(id,uri,\%data,read_flag,\%additional_values);
#		ǡǼޤ
#			id				åID
#			uri				åURI
#			$data{name} = value; or $data{name} = \%value
#			$data{name} = "" Ǻ
# 			id ʤ硢åƥǡ¸ޤ
# 			ΤȤѿ id ˺줿åID ꤵޤ
# 				read_flag			¸Ʊɤ߹ߤԤޤ
# 				%additional_values	Ťǡ񤭤ɲä/$additional_values{̾}=type
# 									ARRAY=ɲ/+=û/.=/,=޶ڤǷ
# 
#	(7)-1 obj->save_by_name(id,uri,name,\%data,\%additional_values);
#		ǡǼޤ
#			name			ǡ̾
#			%data ΤȤ
# 
# ---------------------------------------------------------------------------------------
#	(8)-1 obj->read_by_uri(id,uri,\%data,overwrite_disabled,\@name_order);
#		ǡ%dataɤ߹ߤޤ
#			overwrite_disabled		1=%data ˴ͤǡξ񤭤ػߤ
#			name_order				name γǼ
# 
#	(8)-2 obj->read_by_name(id,uri,name,\%data,overwrite_disabled);
#		ǡ%dataɤ߹ߤޤ
# 
# ---------------------------------------------------------------------------------------
#	(9)-1 obj->reset_by_uri(id,uri);
#		uri Υǡޤ
# 
#	(9)-2 obj->reset_by_name(id,uri,@name);
#		name Υǡޤ
# 
# ---------------------------------------------------------------------------------------
#	(10) obj->log_out(id);
#		桼ޤ
# 
######################################################################
#Ź沽
$Session::salt = 'cM';

######################################################################
#֥Ⱥ
sub new ($$$$) {
my($pkg,$store,$security,$lifetime) = @_;
$security = '' if !defined $security;
$lifetime = 30 if !defined $lifetime || !$lifetime;
my $this = {
	'store' => $store,
	'security' => $security,
	'lifetime' => $lifetime
};
bless $this;
$this;
}

######################################################################
#	(1) obj->is_available(id);
sub is_available ($$) {
my($this,$id) = @_;
return ($id && -f $this->{'store'} . '/' . $id) ? 1 : 0;
}

######################################################################
#	(2) obj->get_user_info(id);
sub get_user_info ($$;$) {
my($this,$sid,$want_email) = @_;
my($email,$pswd,$user_name,$remote_addr,$user_agent);
local(*SESSION);
if ($sid && open(SESSION, $this->{'store'} . '/' . $sid)) {
	binmode SESSION;
	flock(SESSION, LOCK_SH);
	my $user_info = <SESSION>;
	close(SESSION);
	chomp $user_info;
	($email,$pswd,$remote_addr,$user_agent) = split(/\x09/,$user_info);
	return $email if $want_email;
} else {
	return ($want_email) ? undef : (undef,undef);
}

# 󥻥åȯԻȰ㤦åID or 桼IPȰۤʤȤ or 桼ȤȰۤʤȤ => ǧھʤ
if ($this->is_invalid_session_id($email,$sid) || ($this->{'security'} =~ /ip/i && $remote_addr && (!$ENV{'REMOTE_ADDR'} || $remote_addr ne $ENV{'REMOTE_ADDR'})) || ($this->{'security'} =~ /agent/i && $user_agent && (!$ENV{'HTTP_USER_AGENT'} || $user_agent ne $ENV{'HTTP_USER_AGENT'}))) {
	return (undef,undef);
}

if ($pswd && $pswd =~ /:/) {
	my %pass;
	while ($pswd =~ /\G([\w\.]+):([^;]*)(;|$)/g) {
		$pass{$1} = $2;
	}
	return ($email,\%pass);
} else {
	return ($email,$pswd);
}
}

######################################################################
#	(3) obj->mk_session_id
sub mk_session_id ($) {
my $this = shift;
return $ENV{'UNIQUE_ID'} if defined $ENV{'UNIQUE_ID'} && $ENV{'UNIQUE_ID'};
my($id,$salt);
$id = time . $$ . $ENV{'REMOTE_ADDR'};
$id = $cgi::Register->encrypt($id);
if ($id =~ s/\$1\$//g) {
	$id =~ s/\$//g;
	$id = crypt($id,$cgi::Register->rand_char) . crypt($ENV{'REMOTE_ADDR'},$cgi::Register->rand_char);
	$id =~ s/\$1\$//g;
	$id =~ s/\$//g;
}
$id =~ s/\./\-/g;
$id =~ s/\//\_/g;
return $id;
}

######################################################################
#	(4) obj->set_user_info
sub set_user_info ($$$;$) {
my($this,$email,$pswd,$old_id) = @_;
my($user_name,$remote_addr,$user_agent,$new_session,$old_session,$new_id,$new_flag);
$new_id = $this->mk_session_id;
$new_session = $this->{'store'} . '/' . $new_id;
$old_id = $this->get_old_session_id($email) if !$old_id && $email;
$old_session = $this->{'store'} . '/' . $old_id if $old_id;
if (ref $pswd) {
	my $temp = '';
	while (my($k,$v) = each %$pswd) {
		$k =~ s/[^\w\.]/_/g;
		$v =~ s/;/\%3B/g;
		$temp .= (($temp) ? ';' : '') . $k . ':' . $v;
	}
	$pswd = $temp;
} else {
	$pswd =~ s/[:;\s]//sg;
}
local(*OLD,*NEW);
if (open(NEW, ">>$new_session")) {
	binmode NEW;
	flock(NEW, LOCK_EX);
	truncate(NEW, 0);
	seek(NEW, 0, 0);
	print NEW (($email) ? $email : '') . "\x09" . $pswd . "\x09" . $ENV{'REMOTE_ADDR'} . "\x09" . $ENV{'HTTP_USER_AGENT'} . "\x0A";
	if ($old_session && open(OLD, $old_session)) {
		binmode OLD;
		flock(OLD, LOCK_SH);
		my $user_old_info = <OLD>;
		#my($old_email,$old_pswd) = split(/\x09/,$user_old_info);
		#if (!defined $old_pswd || $old_pswd eq '' || ((!$old_email || $old_email eq $email) && $old_pswd eq $pswd)) {
			while (<OLD>) {
				print NEW;
			}
		#}
		close(OLD);
		unlink $old_session;
	} else {
		$new_flag = 1;
	}
	close(NEW);
	chmod($env::file_mode, $new_session);
	$this->gc if defined $new_flag && $new_flag;
	$this->save_session_id($email,$new_id);
	return $new_id;
} else {
	return $old_id;
}
}

sub email_encrypt ($$) {
my($this,$email) = @_;
my $encrypted;
while ($email =~ /([a-zA-Z0-9\/\.]{1,8})/g) {
	$encrypted .= crypt($1, $Session::salt);
}
$encrypted =~ s/\$1\$//g;
$encrypted =~ s/\$//g;
$encrypted =~ s/\./\-/g;
$encrypted =~ s/\//\_/g;
return $encrypted;
}

# ȤȥåIDб¸
sub save_session_id ($$$) {
my($this,$email,$sid) = @_;
return 0 if !$email;
my $path = $this->{'store'} . '/' . $this->email_encrypt($email);
local(*SID);
if (open(SID, ">>$path")) {
	binmode SID;
	flock(SID, LOCK_EX);
	truncate(SID, 0);
	seek(SID, 0, 0);
	print SID $sid;
	close(SID);
	chmod($env::file_mode, $path);
	return 1;
} else {
	return 0;
}
}

sub is_invalid_session_id ($$$) {
my($this,$email,$sid) = @_;
return 0 if !$email;
my $old_sid = $this->get_old_session_id($email);
return ($old_sid && $sid ne $old_sid) ? 1 : 0;
}

sub get_old_session_id ($$) {
my($this,$email) = @_;
return '' if !$email;
my $path = $this->{'store'} . '/' . $this->email_encrypt($email);
local(*SID);
if (open(SID, $path)) {
	my($old_sid);
	binmode SID;
	flock(SID, LOCK_SH);
	$old_sid = <SID>;
	close(SID);
	return $old_sid;
} else {
	return '';
}
}

######################################################################
#	(5) obj->erase(id);
sub erase ($$) {
my($this,$id) = @_;
return 1 if !defined $id;
my $email = $this->get_user_info($id,1);
my $session = $this->{'store'} . '/' . $id;
unlink $session;
unlink $this->{'store'} . '/' . $this->email_encrypt($email) if $email;
return (-f $session) ? 0 : 1;
}

######################################################################
#	(6) obj->gc;
sub gc ($) {
my $this = shift;
my($id);
local(*SESSION);
opendir(SESSION, $this->{'store'});
while ($id = readdir(SESSION)) {
	my $session = $this->{'store'} . '/' . $id;
	unlink $session	if $id !~ /^\./ && -f $session && -M $session > $this->{'lifetime'};
}
closedir(SESSION);
return $this;
}

######################################################################
#	(7)-1 obj->save_by_uri(id,uri,\%data,read_flag,\%additional_values);
sub save_by_uri ($$$$;$@) {
my($this,$id,$uri,$hash,$read_flag,$additional_values) = @_;
my($session,$session_temp,$no_id_flag,%done);
if (!defined $id || !$id || $id =~ /^\.\.\// || $id =~ /pswd=/) {
	$no_id_flag = 1;
	$id = $this->mk_session_id;
	$_[1] = $id;
	$session_temp = $this->{'store'} . '/' . $id;
} else {
	$session = $this->{'store'} . '/' . $id;
	$session_temp = $this->{'store'} . '/' . $id . '.temp';
}
local(*SESSION,*TEMP);
if (open(TEMP, ">>$session_temp")) {
	binmode TEMP;
	flock(TEMP, LOCK_EX);
	truncate(TEMP, 0);
	seek(TEMP, 0, 0);
	if (defined $no_id_flag && $no_id_flag) {
		print TEMP "\x0A";
	} elsif (open(SESSION, $session)) {
		binmode SESSION;
		flock(SESSION, LOCK_SH);
		my $data = <SESSION>;
		print TEMP $data;
		while ($data = <SESSION>) {
			if ($data =~ /^$uri\x09([^\x09]+)\x09(.*)\x0A/) {
				my($key,$value) = ($1,$2);
				if (defined $hash->{$key}) {
					$done{$key} = 1;
					next if !ref $hash->{$key} && $hash->{$key} eq '';
					$this->add($hash->{$key},$value,$additional_values) if ref $hash->{$key} && ref $additional_values;
					print TEMP $this->data($uri,$key,$hash->{$key});
				} else {
					if (defined $read_flag && $read_flag) {
						$done{$key} = 1;
						$this->read_data($hash,$key,$value);
					}
					print TEMP $data;
				}
			} else {
				print TEMP $data;
			}
		}
		close(SESSION);
	} else {
		close(TEMP);
		unlink $session_temp;
		return '';
	}
	my($k,$v);
	while (($k,$v) = each %$hash) {
		print TEMP $this->data($uri,$k,$v) if !$done{$k} && defined $v && (ref $v || $v ne '');
	}	
	close(TEMP);
	if (defined $no_id_flag && $no_id_flag) {
		chmod($env::file_mode, $session_temp);
	} else {
		rename($session_temp,$session);
		chmod($env::file_mode, $session);
	}
	return $id;
} else {
	return '';
}
}

#	(7)-2 obj->save_by_name(id,uri,name,\%data,\%additional_values);
sub save_by_name ($$$$;$@) {
my($this,$id,$uri,$name,$hash,$additional_values) = @_;
my($session,$session_temp,$no_id_flag,$done);
if (!defined $id || !$id || $id =~ /^\.\.\// || $id =~ /pswd=/) {
	$no_id_flag = 1;
	$id = $this->mk_session_id;
	$_[1] = $id;
	$session_temp = $this->{'store'} . '/' . $id;
} else {
	$session = $this->{'store'} . '/' . $id;
	$session_temp = $this->{'store'} . '/' . $id . '.temp';
}
local(*SESSION,*TEMP);
if (open(TEMP, ">>$session_temp")) {
	binmode TEMP;
	flock(TEMP, LOCK_EX);
	truncate(TEMP, 0);
	seek(TEMP, 0, 0);
	if (defined $no_id_flag && $no_id_flag) {
		print TEMP "\x0A";
	} elsif (open(SESSION, $session)) {
		binmode SESSION;
		flock(SESSION, LOCK_SH);
		my $data = <SESSION>;
		print TEMP $data;
		while ($data = <SESSION>) {
			if ($data =~ /^$uri\x09$name\x09(.*)\x0A/) {
				my $value = $1;
				if (defined $hash && (ref $hash || $hash ne '')) {
					$done = 1;
					$this->add($hash,$value,$additional_values) if ref $hash && ref $additional_values;
					print TEMP $this->data($uri,$name,$hash);
				} else {
					next;
				}
			} else {
				print TEMP $data;
			}
		}
		close(SESSION);
	} else {
		close(TEMP);
		unlink $session_temp;
		return '';
	}
	print TEMP $this->data($uri,$name,$hash) if !$done && defined $hash && (ref $hash || $hash ne '');
	close(TEMP);
	if (defined $no_id_flag && $no_id_flag) {
		chmod($env::file_mode, $session_temp);
	} else {
		rename($session_temp,$session);
		chmod($env::file_mode, $session);
	}
	return $id;
} else {
	return '';
}
}

sub data ($$$$;$) {
my($this,$uri,$name,$data,$nokey) = @_;
return '' if !defined $data || $data eq "\x7F";
my($out);
$out = $uri . "\x09" . $name . "\x09" if !$nokey;
if (ref $data eq 'HASH') {
	my($k,$v,$value);
	while (($k,$v) = each %$data) {
		$value .= $this->url_encode($k,$v);
	}
	if (defined $value) {
		$value =~ s/^\&//;
		$out .= $value;
	}
} else {
	$out .= '=' . $data;
}
$out .= "\x0A";
return $out;
}

sub url_encode ($$$) {
my($this,$key,$value) = @_;
my($data,$k,$v);
if (ref $value eq 'ARRAY') {
	my($v,$n);
	$n = 0;
	foreach $v (@$value) {
		$data .= $this->url_encode($key . '^' . $n++,$v);
	}
} elsif (ref $value eq 'HASH') {
	my($k,$v);
	while (($k,$v) = each %$value) {
		$data .= $this->url_encode($key . ':' . $k,$v);
	}
} elsif (defined $key) {
	$value = $$value if ref $value eq 'SCALAR';
	$key =~ s/([\x00-\x1F\x21-\x29\x2B\x2C\x2F\x3A-\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
	$value =~ s/([\x00-\x1F\x21-\x29\x2B\x2C\x2F\x3A-\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg if defined $value;
	$data .= '&' . $key . '=' . ((defined $value) ? $value : '');
}
return $data;
}

sub add ($$$$) {
my($this,$hash,$value,$additional_values) = @_;
if (!ref $hash && defined $value && $value =~ s/^=//) {
	$hash .= (($hash) ? '&' : '') . $value if $additional_values && !ref $additional_values && $additional_values eq '=';
} else {
	while ($value =~ /\G([^=\&]*)=([^\&]*)\&?/sgo) {
		my($k,$v) = ($1,$2);
		$k =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
		if (ref $additional_values && $additional_values->{$k}) {
			$v =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
			if (!defined $hash || !defined $hash->{$k}) {
				$hash->{$k} = $v;
			} elsif (ref $hash && ref $hash->{$k} eq 'ARRAY') {
				push(@{$hash->{$k}},$v);
			} elsif ($hash->{$k} && !ref $hash->{$k}) {
				if ($additional_values->{$k} eq '+') {
					$hash->{$k} += $v;
				} elsif ($additional_values->{$k} eq '.') {
					$hash->{$k} = $v . $hash->{$k};
				} elsif ($additional_values->{$k} eq ',') {
					$hash->{$k} = $v . ',' . $hash->{$k};
				} else {
					my $temp = $hash->{$k};
					$hash->{$k} = [$temp];
				}
			}
		}
	}
}
return $this;
}

######################################################################
#	(8) obj->read_by_uri(id,uri,\%data,overwrite_disabled);
sub read_by_uri ($$$$;$$) {
my($this,$id,$uri,$hash,$overwrite_disabled,$name_order) = @_;
if (!$id || $id =~ /^\.\.\// || $id =~ /pswd=/) {
	$_[1] = '';
	return 0 
}
my $session = $this->{'store'} . '/' . $id;
local(*SESSION);
if (open(SESSION, $session)) {
	binmode SESSION;
	flock(SESSION, LOCK_SH);
	my $data = <SESSION>;
	while ($data = <SESSION>) {
		if ($data =~ /^$uri\x09([^\x09]+)\x09(.*)\x0A/) {
			push(@$name_order,$1) if ref $name_order && ref $name_order eq 'ARRAY';
			$this->read_data(\$hash->{$1},$2,$overwrite_disabled);
		}
	}
	close(SESSION);
	return 1;
} else {
	$_[1] = '';
	return 0;
}
}

sub read_by_name ($$$$$;$) {
my($this,$id,$uri,$name,$hash,$overwrite_disabled) = @_;
if (!$id || $id =~ /^\.\.\// || $id =~ /pswd=/) {
	$_[1] = '';
	return 0 
}
my $session = $this->{'store'} . '/' . $id;
local(*SESSION);
if (open(SESSION, $session)) {
	binmode SESSION;
	flock(SESSION, LOCK_SH);
	my $data = <SESSION>;
	while ($data = <SESSION>) {
		if ($data =~ /^$uri\x09$name\x09(.*)\x0A/) {
			$this->read_data($hash,$2,$overwrite_disabled);
			last;
		}
	}
	close(SESSION);
	return 1;
} else {
	$_[1] = '';
	return 0;
}
}

sub read_data ($$$;$) {
my($this,$hash,$value,$overwrite_disabled) = @_;
if ($value =~ s/^=// && ref $hash eq 'SCALAR') {
	$$hash = $value;
} else {
	$hash = \%{$$hash} if ref $hash eq 'SCALAR';
	while ($value =~ /\G([^=\&]*)=([^\&]*)[\&]?/sgo) {
		my($k,$v) = ($1,$2);
		$k =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
		$v =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
		my $temp = \$hash;
		while ($k =~ /\G([^:\^]+)([\^:]|$)/sg) {
			$temp = (ref $$temp eq 'ARRAY') ? \$$temp->[$1] : \$$temp->{$1};
			if (!$2) {
				last;
			} elsif (!ref $$temp) {
				if ($2 eq '^') {
					$$temp = [];
				} else {
					$$temp = {};
				}
			}
		}
		if ($overwrite_disabled && defined $$temp) {
			next;
		} elsif (defined $$temp && !ref $$temp && $$temp ne '') {
			$$temp = [$$temp,$v];
		} elsif (ref $$temp eq 'ARRAY') {
			push(@$$temp,$v);
		} else {
			$$temp = $v;
		}
	}
}
}

######################################################################
#	(9) obj->reset_by_uri(id,@uri);
sub reset_by_uri ($$@) {
my($this,$id,@uri) = @_;
return 1 if !defined $id || !$id;
my($session,$session_temp);
$session = $this->{'store'} . '/' . $id;
$session_temp = $this->{'store'} . '/' . $id . '.temp';
local(*SESSION,*TEMP);
if (open(SESSION, $session)) {
	binmode SESSION;
	flock(SESSION, LOCK_SH);
	if (open(TEMP, ">>$session_temp")) {
		binmode TEMP;
		flock(TEMP, LOCK_EX);
		truncate(TEMP, 0);
		seek(TEMP, 0, 0);
		my $data = <SESSION>;
		print TEMP $data;
		while ($data = <SESSION>) {
			if (@uri && grep(defined $_ && $_ ne '' && $data =~ /^$_\x09/,@uri)) {
				next;
			} else {
				print TEMP $data;
			}
		}
		close(TEMP);
	} else {
		close(SESSION);
		return 0;
	}
	close(SESSION);
	rename($session_temp,$session);
	chmod($env::file_mode, $session);
	return 1;
} else {
	return 0;
}
}

#	(9) obj->reset_by_name(id,uri,name);
sub reset_by_name ($$$@) {
my($this,$id,$uri,@name) = @_;
return 1 if !defined $id || !$id;
my($session,$session_temp);
$session = $this->{'store'} . '/' . $id;
$session_temp = $this->{'store'} . '/' . $id . '.temp';
local(*SESSION,*TEMP);
if (open(SESSION, $session)) {
	binmode SESSION;
	flock(SESSION, LOCK_SH);
	if (open(TEMP, ">>$session_temp")) {
		binmode TEMP;
		flock(TEMP, LOCK_EX);
		truncate(TEMP, 0);
		seek(TEMP, 0, 0);
		my $data = <SESSION>;
		print TEMP $data;
		while ($data = <SESSION>) {
			if (grep(defined $_ && $_ ne '' && $data =~ /^$uri\x09$_\x09/,@name)) {
				next;
			} else {
				print TEMP $data;
			}
		}
		close(TEMP);
	} else {
		close(SESSION);
		return 0;
	}
	close(SESSION);
	rename($session_temp,$session);
	chmod($env::file_mode, $session);
	return 1;
} else {
	return 0;
}
}

######################################################################
#	(10) obj->log_out(id);
sub log_out ($$$) {
my($this,$id) = @_;
return 1 if !defined $id || !$id;
my($session,$session_temp);
$session = $this->{'store'} . '/' . $id;
$session_temp = $this->{'store'} . '/' . $id . '.temp';
local(*SESSION,*TEMP);
if (open(SESSION, $session)) {
	binmode SESSION;
	flock(SESSION, LOCK_SH);
	if (open(TEMP, ">>$session_temp")) {
		binmode TEMP;
		flock(TEMP, LOCK_EX);
		truncate(TEMP, 0);
		seek(TEMP, 0, 0);
		my $temp = <SESSION>;
		print TEMP "\x0A";
		while ($temp = <SESSION>) {
			print TEMP $temp;
		}
		close(TEMP);
	} else {
		close(SESSION);
		return 0;
	}
	close(SESSION);
	rename($session_temp,$session);
	chmod($env::file_mode, $session);
	return 1;
} else {
	return 0;
}
}

1;
