package ImageLib;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use Fcntl qw(:DEFAULT :flock);
use strict;
######################################################################
# 饤֥Խ⥸塼
# ImageLib.pm ver1.1.5
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2010-02-27
######################################################################
#֥Ⱥ
sub new ($;$$$) {
my($pkg,$key,$deco_obj,$image_css) = @_;
my $this = {};
if (defined $ImageLib::modules{$key} && $ImageLib::modules{$key} ne '') {
	bless $this, $ImageLib::modules{$key};
	$this->{'type'} = $key;
} else {
	bless $this;
	$this->{'type'} = 'image';
}
if (ref $deco_obj) {
	$this->{'deco_obj'} = $deco_obj;
} else {
	require CMONOS::CGI_Lib::Deco;
	$this->{'deco_obj'} = Deco->new;
}
if (!ref $cgi::Image) {
	require CMONOS::CGI_Lib::Image;
	$cgi::Image = Image->new;
}
$this->{'image_css'} = ($image_css) ? $image_css : $env::css . '/image.css';
$this;
}

#񤭹
sub set_deco ($$$$) {
my($this,$dir,$image,$setting) = @_;
return if !$dir || !$image || !$this->{'deco_obj'}->preference_db;
my(%db,$name);
$name = $dir . '_' . $image . '_';
eval 'use ' . $env::dbm_file . ';';
tie(%db, $env::dbm_file, $this->{'deco_obj'}->preference_db, O_RDWR | O_CREAT, $env::dbm_mode);
if (ref tied %db) {
	my($k,$v,@delete);
	while (($k,$v) = each %db) {
		push(@delete,$k) if $k =~ /^$name/;
	}
	foreach (@delete) {
		delete $db{$_};
	}
	while (($k,$v) = each %$setting) {
		next if !defined $k || $k eq '';
		$this->{'deco_obj'}{'setting'}{$dir}{$image}{$k} = $v;
		$v = join("\0",@$v) if ref $v eq 'ARRAY';
		$db{$name . $k} = $v;
	}
} else {
	push(@{$this->{'dialog'}},'ǡ١񤭹ߤ˼Ԥޤ');
}
untie %db;
}

######################################################################
# Ǻ饤֥CSSå
sub image_css_is_ready ($$$$) {
my($this,$image_lib,$dir,$setting) = @_;
return 0;
}

sub read_file ($$) {
my($this,$path) = @_;
my($data);
local(*FILE);
if (open(FILE, $path)) {
	binmode FILE;
	flock(FILE, LOCK_SH);
	$data = join('',<FILE>);
	close(FILE);
}
return (defined $data) ? $data : '';
}

sub write_file ($$$) {
my($this,$path,$data) = @_;
local(*FILE);
if (open(FILE, ">>$path")) {
	binmode FILE;
	flock(FILE, LOCK_EX);
	truncate(FILE, 0);
	seek(FILE, 0, 0);
	print FILE $$data;
	close(FILE);
	chmod($env::file_mode, $path);
	return 1;
} else {
	return 0;
}
}

sub get_image_file_list ($$$) {
my($this,$image_dir,$dir) = @_;
my @img;
local(*DIR);
if (opendir(DIR,"$image_dir/$dir")) {
	@img = grep(-f "$image_dir/$dir/$_" && $_ =~ /^\w+\.(jpg|gif|png)$/i,readdir(DIR));
	closedir(DIR);
}
return @img;
}

sub get_image_dir_list ($$$) {
my($this,$image_dir,$dir) = @_;
my @dir;
local(*DIR);
if (opendir(DIR,"$image_dir/$dir")) {
	@dir = grep(-d "$image_dir/$dir/$_" && $_ =~ /^\w+$/i,readdir(DIR));
	closedir(DIR);
}
return @dir;
}

sub replace_image_css ($$;$) {
my($this,$class_name,$new_css) = @_;
$new_css = '' if !$new_css;
my $image_css = $this->read_file($this->{'image_css'});
$image_css .= "\x0A\x0A" . $new_css unless $image_css =~ s!/\* $class_name start \*/.*?/\* $class_name end \*/\x0A!$new_css!s;
$image_css =~ s/\s+\Z/\x0A/s;
return $this->write_file($this->{'image_css'},\$image_css);
}

sub mk_image_css_for_title ($$$$$;$) {
my($this,$class_name,$setting,$dir,$id,$is_image_lib) = @_;
my($width,$height,$name) = (ref $setting) ? ($setting->{'width'},$setting->{'height'},$setting->{'name'}) : $this->{'deco_obj'}->image_info($dir,$id,$is_image_lib);
my $image_dir = ($is_image_lib) ? '.' : $this->base_change($this->{'deco_obj'}->{'image_dir'},$this->{'image_css'}) . '/' . $dir;
my $css = '/* ' . $class_name . ' start */' . "\x0A";
$css .= 'h1.' . $class_name . ' {' . "\x0A";
$css .= '  width: ' . $width . 'px;' . "\x0A";
$css .= '  height: ' . $height . 'px;' . "\x0A";
$css .= '  background-image: url("' . $image_dir . '/' . $name . '");' . "\x0A";
$css .= '  background-position: left top;' . "\x0A";
$css .= '  background-repeat: no-repeat;' . "\x0A";
$css .= '  text-indent: -4000px;' . "\x0A";
$css .= '  overflow: hidden;' . "\x0A";
$css .= '}' . "\x0A";
$css .= '/* ' . $class_name . ' end */' . "\x0A";
return $css;
}

sub mk_image_css_for_bargraph ($$$$$;$) {
my($this,$class_name,$setting,$dir,$id,$is_image_lib) = @_;
my($width,$height,$name) = (ref $setting) ? ($setting->{'width'},$setting->{'height'},$setting->{'name'}) : $this->{'deco_obj'}->image_info($dir,$id,$is_image_lib);
my $image_dir = ($is_image_lib) ? '.' : $this->base_change($this->{'deco_obj'}->{'image_dir'},$this->{'image_css'}) . '/' . $dir;
my $css = '/* ' . $class_name . ' start */' . "\x0A";
$css .= 'div.' . $class_name . ' {' . "\x0A";
$css .= '  width: 200px;' . "\x0A";
$css .= '  height: ' . $height . 'px !important;' . "\x0A";
$css .= '  margin: 0;' . "\x0A";
$css .= '  padding: 0;' . "\x0A";
$css .= '  background-color: ' . (($dir eq 'bargraphbg') ? '#eee' : '#666') . ';' . "\x0A";
$css .= '  background-image: url("' . $image_dir . '/' . $name . '");' . "\x0A";
$css .= '  text-align: left;' . "\x0A" if $dir eq 'bargraphbg';
$css .= '}' . "\x0A";
$css .= 'div.' . $class_name . ' .barimage {display: none}' . "\x0A" if $dir eq 'bargraph';
$css .= '/* ' . $class_name . ' end */' . "\x0A";
return $css;
}

sub add_setting_hash ($$$$$) {
my($this,$setting,$new_setting,$dir,$id) = @_;
my($k,$v,$name);
$name = $dir . '_' . $id . '_';
while (($k,$v) = each %$new_setting) {
	$setting->{$name . $k} = $v;
}
}

######################################################################
# 
sub erase ($) {
my $this = shift;
unlink("$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif");
unlink("$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.jpg");
unlink("$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.png");
$this->replace_image_css($main::dir . '-' . $main::id) if $main::dir eq 'bargraph' || $main::dir eq 'bargraphbg' || $main::dir eq 'title';
}

######################################################################
# ˥塼
sub menu ($$;$$$) {
my($this,$name,$lib_dir,$id,$list) = @_;
return $this->{'deco_obj'}->image_menu($name,$main::dir,100,$id,1,$list,$lib_dir,$main::id);
}

######################################################################
# ե
sub print_setting_form ($) {
my $this = shift;
return if !defined $main::dir || $main::dir eq 'bargraph' || $main::dir eq 'bargraphbg' || (defined $setting::deco_option{$main::dir} && ($setting::deco_option{$main::dir} eq 'noalt' || $setting::deco_option{$main::dir} eq 'nosave'));
print '<fieldset><legend><label for="setting:alt">إƥ</label></legend>';
print '<input type="text" name="setting:alt" id="setting:alt" value="' . $cgi::action->escape($this->{'deco_obj'}{'setting'}{$main::dir}{$main::id}{'alt'}) . '" size="20" />';
print ' <input type="submit" value="¸" />' if defined $main::id && $main::id ne '';
print '</fieldset>';
}

######################################################################
# Ͽ
sub set_image ($) {
my $this = shift;
return if defined $setting::deco_option{$main::dir} && $setting::deco_option{$main::dir} eq 'nosave';
my %image_info;
my $class_name = $main::dir . '-' . $main::id;
($image_info{'width'},$image_info{'height'},$image_info{'name'}) = $this->{'deco_obj'}->image_info($main::dir,$main::id);
if ($main::dir eq 'bargraph' || $main::dir eq 'bargraphbg') {
	$this->replace_image_css($class_name,$this->mk_image_css_for_bargraph($class_name,\%image_info,$main::dir,$main::id));
	delete $image_info{'width'};
	delete $image_info{'name'};
} else {
	if ($main::dir eq 'title') {
		$this->replace_image_css($class_name,$this->mk_image_css_for_title($class_name,\%image_info,$main::dir,$main::id));
		undef %image_info;
	}
	if ((!defined $setting::deco_option{$main::dir} || $setting::deco_option{$main::dir} ne 'noalt') && defined $main::setting{'alt'}) {
		$image_info{'alt'} = $main::setting{'alt'};
	}
}
$this->set_deco($main::dir,$main::id,\%image_info) if %image_info;
}

######################################################################
# åץɥե
sub print_upload_form ($$) {
my($this,$save_button) = @_;
print '<fieldset><legend><label for="image:image">ꥸʥ</label></legend>';
print '<input type="file" name="image:image" id="image:image" />';
print '<input type="submit" value="' . $save_button . '" /></fieldset>';
}

######################################################################
# ¸
sub save_images ($) {
my $this = shift;
return 0 if !ref $cgi::input || $cgi::Image->is_not_web_image($cgi::input);

#Ťκ
unlink "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif";
unlink "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.jpg";
unlink "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.png";

#¸
$cgi::input->save_file(
	'image:image',
	'!' . $main::id,
	[
		'image/gif:gif',
		'image/jpeg:jpg',
		'image/pjpeg:jpg',
		'image/x-png:png',
		'image/png:png'
	],
	10000000,
	"$this->{'deco_obj'}->{'image_dir'}/$main::dir",
);
$cgi::input->clear_clipboard;
push(@{$cgi::action->{'dialog'}},$cgi::input->dialog) if ref $cgi::action;
return 1;
}

######################################################################
# 饤֥꤫Υݡ
sub import_images ($) {
my $this = shift;
my $type = (-f "$this->{'deco_obj'}->{'image_lib'}/$main::dir/$main::img.gif") ? 'gif' : (-f "$this->{'deco_obj'}->{'image_lib'}/$main::dir/$main::img.png") ? 'png' : (-f "$this->{'deco_obj'}->{'image_lib'}/$main::dir/$main::img.jpg") ? 'jpg' : '';
if ($type && $this->set_dir("$this->{'deco_obj'}->{'image_dir'}/$main::dir")) {
	unlink "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif" if $type ne 'gif';
	unlink "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.jpg" if $type ne 'jpg';
	unlink "$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.png" if $type ne 'png';
	if (!defined $main::color || $main::color eq '' || $type ne 'gif') {
		$this->file_copy("$this->{'deco_obj'}->{'image_lib'}/$main::dir/$main::img.$type","$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.$type");
		push(@{$cgi::action->{'dialog'}},'ۿɽѹ GIF ˤΤŬѤޤ') if ref $cgi::action && $main::color;
		return 1;
	} elsif (defined $main::color && $main::color eq 'slide' && defined $main::slide{'color'} && $main::slide{'color'} =~ /([0-9a-fA-F]{6}|random)/i) {
		if (!$this->set_dir("$this->{'deco_obj'}->{'image_dir'}/$main::dir")) {
			push(@{$cgi::action->{'dialog'}},'Ǽǥ쥯ȥ򳫤ޤǤ') if ref $cgi::action;
			return 0;
		}
		$cgi::Image->change_color_table(
			"$this->{'deco_obj'}->{'image_lib'}/$main::dir/$main::img.gif",
			"$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif",
			'slide',
			$main::slide{'color'},
			$main::slide{'abs'},
			$main::slide{'rev'}
		);
		return 1;
	} elsif (defined $main::color && $main::color eq 'change' && defined $main::change{'color'} && $main::change{'color'} =~ /([0-9a-fA-F]{6}|random)/i) {
		if (!$this->set_dir("$this->{'deco_obj'}->{'image_dir'}/$main::dir")) {
			push(@{$cgi::action->{'dialog'}},'Ǽǥ쥯ȥ򳫤ޤǤ') if ref $cgi::action;
			return 0;
		}
		$cgi::Image->change_color_table(
			"$this->{'deco_obj'}->{'image_lib'}/$main::dir/$main::img.gif",
			"$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif",
			'change',
			$main::change{'color'}
		);
		return 1;
	}
}
push(@{$cgi::action->{'dialog'}},'ޤ') if ref $cgi::action;
return 0;
}

sub change_image_color ($) {
my $this = shift;
if (!$this->set_dir("$this->{'deco_obj'}->{'image_dir'}/$main::dir")) {
	push(@{$cgi::action->{'dialog'}},'Ǽǥ쥯ȥ򳫤ޤǤ') if ref $cgi::action;
	return 0;
}
if (defined $main::color && $main::color eq 'slide' && $main::slide{'color'} =~ /([0-9a-fA-F]{6}|random)/i) {
	$cgi::Image->change_color_table(
		"$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif",
		"$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif",
		'slide',
		$main::slide{'color'},
		$main::slide{'abs'},
		$main::slide{'rev'}
	);
	return 1;
} elsif (defined $main::color && $main::color eq 'change' && $main::change{'color'} =~ /([0-9a-fA-F]{6}|random)/i) {
	$cgi::Image->change_color_table(
		"$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif",
		"$this->{'deco_obj'}->{'image_dir'}/$main::dir/$main::id.gif",
		'change',
		$main::change{'color'}
	);
	return 1;
}
return 1;
}

######################################################################
# ID
sub get_id ($$) {
my($this,$dir) = @_;
if (opendir(DIR,$this->{'deco_obj'}->{'image_dir'} . '/' . $dir)) {
	my $num = 0;
	while (1) {
		$num++;
		my $path = $this->{'deco_obj'}->{'image_dir'} . '/' . $dir . '/' . $num;
		last if !-f $path . '.gif' && !-f $path . '.jpg' && !-f $path . '.png';
	}
	return $num;
} else {
	return 1;
}
}


1;