package CalCommon;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
######################################################################
# åȥåץ⥸塼
# CalCommon.pm ver1.0.2
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-05-03
######################################################################
use Time::Local;
sub dt_stamp ($$$$) {
my($this,$year,$mon,$mday,$hour,$min,$isdate) = @_;
return $year . sprintf("%.2d", $mon) . sprintf("%.2d", $mday) . (($isdate || !defined $hour) ? '' : 'T' . sprintf("%.2d", $hour) . sprintf("%.2d", $min) . "00");
}

sub dt_to_time ($$) {
my($this,$dt) = @_;
if ($dt =~ /^(\d{4})(\d{2})(\d{2})T(\d{2})(\d{2})(\d{2})Z?$/) {
	return timelocal(($6 + 0),($5 + 0),($4 + 0),($3 + 0),($2 - 1),$1);
} elsif ($dt =~ /^(\d{4})(\d{2})(\d{2})$/) {
	return timelocal(0,0,0,($3 + 0),($2 - 1),$1);
} else {
	return 0;
}
}

sub dt_fix($$) {
my($this,$dt,$isdate) = @_;
my($y,$m,$d,$h,$min,$sec);
if ($dt =~ /^(\d{4})(\d{2})(\d{2})T(\d{2})(\d{2})(\d{2})Z?$/) {
	($y,$m,$d,$h,$min,$sec) = ($1,$2+0,$3+0,$4+0,$5+0,$6+0);
	$h = 23 if $h > 23;
	$min = 59 if $min > 59;
	$sec = 59 if $sec > 59;
} elsif ($dt =~ /^(\d{4})(\d{2})(\d{2})$/) {
	($y,$m,$d,$h,$min,$sec) = ($1,$2+0,$3+0,0,0,0);
	if (!$isdate && $setting::general{'dateDisabled'}) {
		$h = (localtime(time))[2];
	} else {
		$isdate = 1;
	}
} else {
	return $this->time_to_dtstamp(time,$isdate);
}
if ($m > 12) {
	$m = 12;
} elsif ($m == 0) {
	$m = 1;
}
if ($d > 31) {
	$d = 31;
} elsif ($m == 0) {
	$d = 1;
}
if ($this->is_impossible_mday($y,$m,$d)) {
	$d = $this->get_last_mday($y,$m);
}
return $this->dt_stamp($y,$m,$d,$h,$min,$isdate);
}

sub time_to_dtstamp ($;$$) {
my($this,$time,$isdate) = @_;
$time = time if !defined $time || $time eq '';
my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($time);
$year += 1900;
$mon++;
return $year . sprintf("%.2d", $mon) . sprintf("%.2d", $mday) .  (($isdate) ? '' : 'T' . sprintf("%.2d", $hour) .sprintf("%.2d", $min) . sprintf("%.2d", $sec));
}

sub get_dt_gap ($$$;$) {
my($this,$s,$e,$isdate) = @_;
my $gap = $this->dt_to_time($e) - $this->dt_to_time($s);
return ($isdate) ? int($gap / 86400) + (($gap % 86400) ? 1 : 0) : $gap;
}

sub timestamp_to_array ($$) {
my($this,$dt) = @_;
if ($dt =~ /^(\d{4})(\d{2})(\d{2})T?(\d{2})(\d{2})(\d{2})Z?$/) {
	return ($1,($2+0),($3+0),($4+0),($5+0),($6+0));
} elsif ($dt =~ /^(\d{4})(\d{2})(\d{2})$/) {
	return ($1,($2+0),($3+0),0,0,0);
} else {
	return ();
}
}

sub get_hash_from_rrule ($$) {
my($this,$rrule) = @_;
return () if !$rrule;
my %hash = ();
while ($rrule =~ /\G(\w+)=([\w,]+);?/g) {
	my($k,$v) = ($1,$2);
	$hash{$k} = ($v =~ /,/) ? [split(/,/,$v)] : $v;
}
return %hash;
}

sub get_prev_date ($$;$) {
my($this,$dt,$interval) = @_;
return $dt if defined $interval && $interval ne '' && $interval == 0;
$interval = 1 if !$interval;
if ($dt =~ /^(\d{4})(\d{2})(\d{2})/) {
	my($y,$m,$d) = $this->get_prev_date_array($1,$2+0,$3+0,$interval);
	return $y . sprintf("%.2d", $m) . sprintf("%.2d", $d);
}
return $dt;
}

sub get_prev_date_array ($$$$;$) {
my($this,$y,$m,$d,$interval) = @_;
return($y,$m,$d) if defined $interval && $interval ne '' && $interval == 0;
$interval = 1 if !$interval;
$d -= $interval;
while ($d < 1) {
	if ($m == 1) {
		$y--;
		$m = 12;
	} else {
		$m--;
	}
	$d += $this->get_last_mday($y,$m);
}
return($y,$m,$d);
}

sub get_next_date ($$;$) {
my($this,$dt,$interval) = @_;
return $dt if defined $interval && $interval ne '' && $interval == 0;
$interval = 1 if !$interval;
if ($dt =~ /^(\d{4})(\d{2})(\d{2})/) {
	my($y,$m,$d) = $this->get_next_date_array($1,$2+0,$3+0,$interval);
	return $y . sprintf("%.2d", $m) . sprintf("%.2d", $d);
}
return $dt;
}

sub get_next_date_array ($$$$;$) {
my($this,$y,$m,$d,$interval) = @_;
return($y,$m,$d) if defined $interval && $interval ne '' && $interval == 0;
$interval = 1 if !$interval;
$d += $interval;
while ((($m == 4 || $m == 6 || $m == 9 || $m == 11) && $d > 30) || ($m == 2 && $d > (($this->is_leap_year($y)) ? 29 : 28)) || $d > 31) {
	$d -= $this->get_last_mday($y,$m);
	if ($m == 12) {
		$y++;
		$m = 1;
	} else {
		$m++;
	}
}
return($y,$m,$d);
}

sub get_last_mday ($$$) {
my($this,$y,$m) = @_;
return (($m == 4 || $m == 6 || $m == 9 || $m == 11) ? 30 : ($m == 2 && $this->is_leap_year($y)) ? 29 : ($m == 2) ? 28 : 31);
}

sub number_to_wday ($$) {
my($this,$n) = @_;
my @week = ('SU','MO','TU','WE','TH','FR','SA');
return $week[$n];
}

sub wday_to_number ($$) {
my($this,$d) = @_;
my %w = ('SU' => 0,'MO' => 1,'TU' => 2,'WE' => 3,'TH' => 4,'FR' => 5,'SA' => 6);
if (ref $d && ref $d eq 'ARRAY') {
	return map($w{$_},@$d);
} else {
	return $w{$d};
}
}

sub dt_to_wday ($$) {
my($this,$dt) = @_;
if ($dt =~ /^(\d{4})(\d{2})(\d{2})/) {
	return $this->get_wday($1,$2+0,$3+0);
} else {
	return 0;
}
}

sub set_event_data ($$$) {
my($this,$date,$event) = @_;
$this->{'date'} = $date;
$this->{'event'} = $event;
}

sub get_tool_buttons ($$;$$) {
my($this,$n,$id,$is_opened) = @_;
if ($this->is_secure('revise')) {
	$this->use_icon('calendar') if !$cgi::icon;
	my $url = $cgi::path . '?m=Editor&amp;k=editor' . (($default::subdivided && $main::c) ? '&amp;c=' . $main::c : '') . '&amp;n=' . $n . '&amp;v=' . (($main::v) ? $main::v : '');
	my $button = '';
	$button = '<div id="' . $id . '">' if $id;
	$button .= $cgi::icon->button(
		'eventedit',
		$setting::page{$setting::key}{'eventedit'},
		$url,
		' &gt; ',
		(($is_opened) ? () : ('detailViewer',{'onclick' => $this->detail_viewer_opener}))
	);
	if ($this->is_secure('delete',0,'revise')) {
		$button .= $cgi::icon->button(
			'eventdelete',
			$setting::page{$setting::key}{'eventdelete'},
			$url . '&amp;delete=1',
			' x ',
			(($is_opened) ?
				   ('',				{'onclick' => "return confirm('ϼäޤ˺ޤ')"})
				 : ('detailViewer',	{'onclick' => "return confirm('ϼäޤ˺ޤ') && " . $this->detail_viewer_opener})
			)
		);
	}
	$button .= '</div>' if $id;
	return $button;
} else {
	return '';
}
}

sub detail_viewer_opener ($) {
my $this = shift;
return "cmonos.window.open('detailViewer'," . (($setting::page{'detailWindowWidth'}) ? $setting::page{'detailWindowWidth'} : '640') . "," . (($setting::page{'detailWindowHeight'}) ? $setting::page{'detailWindowHeight'} : '480') . ")";
}

sub get_event_dt ($$$$$$$$$$$$$$$$$$$$$) {
my($this,$sy,$sm,$sd,$sh,$smin,$ey,$em,$ed,$eh,$emin,$uy,$um,$ud,$date,$indefinite,$freq,$by,$interval,$byday,$se_gap,$for_tooltip) = @_;
my($dey,$dem,$ded,$event_dt,$spacer,$separator);
($dey,$dem,$ded) = $this->get_prev_date_array($ey,$em,$ed) if $date;
$event_dt = '';
if ($for_tooltip) {
	$spacer = '';
	$separator = '-';
} else {
	$spacer = ' ';
	$separator = '  ';
}

#٥Ȥ
if ($freq) {
	if ($freq eq 'daily' || $freq eq 'weekly') {
		if ($freq eq 'daily') {
			$event_dt = ($interval == 1) ? '' : $interval . '';
		} elsif ($freq eq 'weekly') {
			$event_dt = ($interval == 1) ? '轵' : $interval . '';
			if (@$byday == 5 && !grep($_ !~ /^(MO|TU|WE|TH|FR)$/,@$byday)) {
				$event_dt .= $spacer . 'ʿ';
			} else {
				$event_dt .= $spacer . '' if grep($_ eq 'SU',@$byday);
				$event_dt .= $spacer . '' if grep($_ eq 'MO',@$byday);
				$event_dt .= $spacer . '' if grep($_ eq 'TU',@$byday);
				$event_dt .= $spacer . '' if grep($_ eq 'WE',@$byday);
				$event_dt .= $spacer . '' if grep($_ eq 'TH',@$byday);
				$event_dt .= $spacer . '' if grep($_ eq 'FR',@$byday);
				$event_dt .= $spacer . '' if grep($_ eq 'SA',@$byday);
				$event_dt .= '' if !$for_tooltip && @$byday == 1;
			}
		}
		if (!$date) {
			$event_dt .= $spacer . $sh . ':' . sprintf("%.2d", $smin) . $separator;
			if ($sy == $ey && $sm == $em && $sd == $ed) {
				$event_dt .= $eh . ':' . sprintf("%.2d", $emin);
			} else {
				$event_dt .= ' ' . $eh . ':' . sprintf("%.2d", $emin);
			}
		}
	} else {
		my $se_dgap = int((($date) ? $se_gap : $se_gap + $sh * 3600 + $smin * 60) / 86400);
		if ($freq eq 'monthly') {
			$event_dt = ($interval == 1) ? '' : $interval . '';
			if ($by && $by eq 'bywday') {
				$event_dt .= ' ' . (int($sd / 7) + (($sd % 7) ? 1 : 0)) . $this->get_wday_name($sy,$sm,$sd) . '';
			} else {
				$event_dt .= $spacer . $sd . '';
			}
		} elsif ($freq eq 'yearly') {
			$event_dt = ($interval == 1) ? 'ǯ' : $interval . 'ǯ';
			$event_dt .= $spacer . $sm . (($for_tooltip) ? '/' . $sd : '' . $sd . '');
		}
		if ($date) {
			if ($se_dgap > 1) {
				if ($freq eq 'yearly' && $by eq 'bymday') {
					$event_dt .= $separator . (($dey > $sy) ? 'ǯ' . $spacer : '') . $dem . '' . $ded . '';
				} else {
					$event_dt .= $separator . $se_dgap . '';
				}
			}
		} else {
			$event_dt .= $spacer . $sh . ':' . sprintf("%.2d", $smin) . $separator;
			if ($sy == $ey && $sm == $em && $sd == $ed) {
				$event_dt .= $spacer . $sh . ':' . sprintf("%.2d", $smin) . $separator . $eh . ':' . sprintf("%.2d", $emin);
			} else {
				$event_dt .= (($se_dgap == 1) ? '' : $se_dgap . '') . $spacer . $eh . ':' . sprintf("%.2d", $emin);
			}
		}
	}
	return $event_dt if $for_tooltip;
	if (!$indefinite) {
		$event_dt .= '<div class="note">[:' . $this->event_date_text($sy,$sm,$sd,$for_tooltip);
		$event_dt .= $separator . $uy . 'ǯ' . $um . '' . $ud . '(' . $this->get_wday_name($uy,$um,$ud) . ')]</div>';
	}
	$event_dt .= '<div class="note">[:';
}
$event_dt .= $this->event_date_text($sy,$sm,$sd,$for_tooltip);
if ($date) {
	$event_dt .= $separator . $this->event_date_text($dey,$dem,$ded,$for_tooltip) if $se_gap > 86400;
} elsif ($for_tooltip) {
	$event_dt .= $separator . $this->event_date_text($ey,$em,$ed,1) if $se_gap > 86400;
} else {
	$event_dt .= $spacer . $sh . ':' . sprintf("%.2d", $smin) . $separator;
	if ($sy == $ey && $sm == $em && $sd == $ed) {
		$event_dt .= $eh . ':' . sprintf("%.2d", $emin);
	} else {
		$event_dt .= $this->event_date_text($ey,$em,$ed,$for_tooltip) . $spacer . $eh . ':' . sprintf("%.2d", $emin);
	}
}
$event_dt .= ']</div>' if $freq;
return $event_dt;
}

sub event_date_text ($$$$;$) {
my($this,$y,$m,$d,$for_tooltip) = @_;
if ($for_tooltip) {
	return $m . '/' . $d;
} else {
	return $y . 'ǯ' . $m . '' . $d . '(' . $this->get_wday_name($y,$m,$d) . ')';
}
}

sub is_available_wday ($$$$) {
my($this,$available_wday_array,$y,$m,$d,$holiday) = @_;
my $w = $this->get_wday($y,$m,$d);
my $is_holiday = ($w != 0 && ref $holiday && grep($_ == 7,@$available_wday_array) && $holiday->jp($y)->name($m,$d)) ? 1 : 0;
if (
		(grep($_ == $w,@$available_wday_array) && !$is_holiday)
	||	(!grep($_ == $w,@$available_wday_array) && $is_holiday)
) {
	return 1;
} else {
	return 0;
}
}

sub is_required_date ($$$$$$$$$$) {
my($this,$dt,$rrule_hash,$start_date,$end_date,$ymd,$y,$m,$d,$md,$prev_ref,$next_ref) = @_;
if ($dt !~ /^\d{8}$/ && $rrule_hash->{'FREQ'} && $rrule_hash->{'INTERVAL'}) {
	return 0 if $ymd < $start_date;
	if ($rrule_hash->{'FREQ'} eq 'DAILY') {
		return 0 if $$prev_ref && $ymd == $start_date;
		if ($rrule_hash->{'INTERVAL'} > 1) {
			my $dgap = ($$prev_ref) ? $this->get_dt_gap($end_date,$ymd,1) : $this->get_dt_gap($start_date,$ymd,1);
			return 0 if $dgap % $rrule_hash->{'INTERVAL'};
		}
	} elsif ($rrule_hash->{'FREQ'} eq 'WEEKLY') {
		return 0 if $$prev_ref && $ymd == $start_date;
		if ($rrule_hash->{'INTERVAL'} > 1) {
			my $dgap = ($$prev_ref) ? $this->get_dt_gap($end_date,$ymd,1) : $this->get_dt_gap($start_date,$ymd,1);
			return 0 if int($dgap / 7) % $rrule_hash->{'INTERVAL'};
		}
	} elsif ($rrule_hash->{'FREQ'} eq 'MONTHLY') {
		if ($start_date =~ /^(\d{4})(\d{2})(\d{2})$/) {
			my($sy,$sm,$sd) = ($1,$2,$3);
			if ($rrule_hash->{'INTERVAL'} > 1) {
				my $mgap = ($y - $sy) * 12 + $m - $sm;
				$mgap-- if $$prev_ref && $$prev_ref >= $d;
				return 0 if $mgap % $rrule_hash->{'INTERVAL'};
			}
			if ($rrule_hash->{'BYMONTHDAY'}) {
				if ($$prev_ref && $$prev_ref >= $d) {
					my $gap = 31 - $this->get_last_mday($this->get_prev_ym($y,$m));
					$$next_ref += $gap;
					$$prev_ref -= $gap;
					return 0 if $$next_ref < 0;
				}
			} elsif ($dt =~ /^\d[A-Z]{2}$/ && ref $rrule_hash->{'BYDAY'} && $rrule_hash->{'BYDAY'}[0] && $rrule_hash->{'BYDAY'}[0] =~ /^(\d)([A-Z]{2})$/) {
				my($wn,$wd) = ($1+0,$this->wday_to_number($2));
				my($sy,$sm,$sd,$fw);
				if ($$prev_ref && $$prev_ref >= $d) {
					($sy,$sm) = $this->get_prev_ym($y,$m);
				} else {
					($sy,$sm) = ($y,$m);
				}
				$fw = $this->get_wday($sy,$sm,1);
				$sd = $wn * 7 + $wd + (($wd < $fw) ? 1 : -6) - $fw;
				return 0 if $this->is_impossible_mday($sy,$sm,$sd);
				my $sdt = $this->dt_stamp($sy,$sm,$sd);
				my $dgap = $this->get_dt_gap($sdt,$ymd,1);
				return 0 if $sdt < $start_date;
				my $se_dgap = $$prev_ref + $$next_ref;
				return 0 if $dgap < 0 || $dgap > $se_dgap;
				$$prev_ref = $dgap;
				$$next_ref = $se_dgap - $dgap;
			}
		}
	} elsif ($rrule_hash->{'FREQ'} eq 'YEARLY') {
		if ($start_date =~ /^(\d{4})(\d{4})$/) {
			my($sy,$smd) = ($1,$2);
			if ($rrule_hash->{'INTERVAL'} > 1) {
				my $ygap = $y - $sy - (($md < $smd) ? 1 : 0);
				return 0 if $ygap % $rrule_hash->{'INTERVAL'};
			}
			if ($$prev_ref) {
				my $ly = ($smd lt "0229") ? $sy : ($sy + 1);
				my $ldate = $ly . "0229";
				if ($this->is_leap_year($ly) && $ldate < $end_date) {
					if ($ymd < $ldate) {
						$$next_ref++;
					} else {
						$$prev_ref++;
					}
				}
			}
		}
	}
}
return 1;
}

sub get_prev_ym ($$$) {
my($this,$y,$m) = @_;
$m--;
if ($m == 0) {
	$m = 12;
	$y--;
}
return ($y,$m);
}

sub get_event_date_info ($$$;$$) {
my($this,$dt_start,$dt_end,$rrule,$for_tooltip) = @_;
my($sy,$sm,$sd,$sh,$smin,$ey,$em,$ed,$eh,$emin,$uy,$um,$ud,$date,$indefinite,$freq,$by,$interval,@byday,$dt_start_time,$dt_end_time,$se_gap);
use Time::Local;
return '' if !$dt_start;
$date = 1 if $dt_start =~ /^\d{8}$/;
($sy,$sm,$sd,$sh,$smin) = $this->timestamp_to_array($dt_start);
($ey,$em,$ed,$eh,$emin) = $this->timestamp_to_array($dt_end);
if (ref $rrule && %$rrule) {
	if ($rrule->{'FREQ'}) {
		$freq = lc $rrule->{'FREQ'};
		if ($rrule->{'UNTIL'}) {
			if ($rrule->{'UNTIL'} =~ /^(\d{8})T\d{6}Z$/) {
				my $udt = $1;
				if ($ENV{'TZ'} && $ENV{'TZ'} =~ /(\-?)(\d+)$/ && !$1 && $2) {
					$udt = $this->get_prev_date($udt)
				}
				($uy,$um,$ud) = $this->timestamp_to_array($udt);
			} else {
				($uy,$um,$ud) = $this->timestamp_to_array($rrule->{'UNTIL'});
			}
			($uy,$um,$ud) = $this->timestamp_to_array($rrule->{'UNTIL'});
		} else {
			$indefinite = 1;
		}
		$interval = ($rrule->{'INTERVAL'}) ? $rrule->{'INTERVAL'} : 1;
		if ($rrule->{'BYDAY'}) {
			$this->scalar_to_array(\$rrule->{'BYDAY'});
			@byday = @{$rrule->{'BYDAY'}};
			if ($freq eq 'monthly') {
				$by = 'bywday';
				@byday = grep($_ =~ s/^\d+//g,@{$rrule->{'BYDAY'}});
			}
		}
		$by = 'bymday' if $rrule->{'BYMONTHDAY'};
	}
}
$dt_start_time = timelocal(0,(($date) ? 0 : $smin),(($date) ? 0 : $sh),$sd,($sm - 1),$sy);
$dt_end_time = timelocal(0,(($date) ? 0 : $emin),(($date) ? 0 : $eh),$ed,($em - 1),$ey);
$se_gap = $dt_end_time - $dt_start_time;
return $this->get_event_dt($sy,$sm,$sd,$sh,$smin,$ey,$em,$ed,$eh,$emin,$uy,$um,$ud,$date,$indefinite,$freq,$by,$interval,\@byday,$se_gap,$for_tooltip);
}

######################################################################
# åȥå
#sub import {
BEGIN {
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#DBɤ߹
	$setting::general = 1;				#ɤ߹
	$setting::deco = 1;					#ƥɤ߹
	$setting::security = 1;				#ɤ߹
	$setting::table = 1;				#ơ֥ɤ߹
	$setting::page = 1;					#ڡɤ߹

	#å
	$cookie::id_enabled = 1;					#ID󥯥åɤ߹

	#եɤ߹
	$setting::field_db_name = 'inputfield';		#եDB
	$setting::field = 2;					#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 0;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';			#tag=Τ/all=Ƥ/no=Ĥʤ

	#ɬܥե
	@setting::form = ('k','m','and','search') if !@setting::form;

	#ǥեȲ̤Ĵ
	if ($default::subdivided && defined $main::c && $main::c ne '') {
		unshift(@setting::form,'c');
	}

	#᡼CSS
	$setting::image_css = 'calendar-image.css';

} else {
	$main::m = $default::m = 'Index';
	$main::k = $default::k = 'index';
	require CMONOS::Calendar::Index;
}
}

1;
