package Ics;
require CMONOS::Calendar::CalCommon;
@ISA = qw(CalCommon);
use strict;
######################################################################
# icsե񤭽Ф⥸塼
# Ics.pm ver1.1.7
# Copyright (C) 1999-2011 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# ǽ2011-06-05
######################################################################
sub _tz_to_id ($$) {
my($this,$tzname) = @_;
my %tzname_to_tzid = (
	'ACT'	=>	'Australia/Darwin',
	'AET'	=>	'Australia/Sydney',
	'AGT'	=>	'America/Buenos_Aires',
	'ART'	=>	'Africa/Cairo',
	'AST'	=>	'America/Anchorage',
	'America/Atka'	=>	'America/Adak',
	'America/Ensenada'	=>	'America/Tijuana',
	'America/Fort_Wayne'	=>	'America/Indianapolis',
	'America/Indiana/Indianapolis'	=>	'America/Indianapolis',
	'America/Kentucky/Louisville'	=>	'America/Louisville',
	'America/Knox_IN'	=>	'America/Indiana/Knox',
	'America/Porto_Acre'	=>	'America/Rio_Branco',
	'America/Rosario'	=>	'America/Cordoba',
	'America/Shiprock'	=>	'America/Denver',
	'America/Virgin'	=>	'America/St_Thomas',
	'Antarctica/South_Pole'	=>	'Antarctica/McMurdo',
	'Arctic/Longyearbyen'	=>	'Europe/Oslo',
	'Asia/Ashkhabad'	=>	'Asia/Ashgabat',
	'Asia/Chungking'	=>	'Asia/Chongqing',
	'Asia/Dacca'	=>	'Asia/Dhaka',
	'Asia/Istanbul'	=>	'Europe/Istanbul',
	'Asia/Macao'	=>	'Asia/Macau',
	'Asia/Tel_Aviv'	=>	'Asia/Jerusalem',
	'Asia/Thimbu'	=>	'Asia/Thimphu',
	'Asia/Ujung_Pandang'	=>	'Asia/Makassar',
	'Asia/Ulan_Bator'	=>	'Asia/Ulaanbaatar',
	'Australia/ACT'	=>	'Australia/Sydney',
	'Australia/Canberra'	=>	'Australia/Sydney',
	'Australia/LHI'	=>	'Australia/Lord_Howe',
	'Australia/NSW'	=>	'Australia/Sydney',
	'Australia/North'	=>	'Australia/Darwin',
	'Australia/Queensland'	=>	'Australia/Brisbane',
	'Australia/South'	=>	'Australia/Adelaide',
	'Australia/Tasmania'	=>	'Australia/Hobart',
	'Australia/Victoria'	=>	'Australia/Melbourne',
	'Australia/West'	=>	'Australia/Perth',
	'Australia/Yancowinna'	=>	'Australia/Broken_Hill',
	'BET'	=>	'America/Sao_Paulo',
	'BST'	=>	'Asia/Dhaka',
	'Brazil/Acre'	=>	'America/Porto_Acre',
	'Brazil/DeNoronha'	=>	'America/Noronha',
	'Brazil/East'	=>	'America/Sao_Paulo',
	'Brazil/West'	=>	'America/Manaus',
	'CAT'	=>	'Africa/Harare',
	'CNT'	=>	'America/St_Johns',
	'CST'	=>	'America/Chicago',
	'CST6CDT'	=>	'America/Chicago',
	'CTT'	=>	'Asia/Shanghai',
	'Canada/Atlantic'	=>	'America/Halifax',
	'Canada/Central'	=>	'America/Winnipeg',
	'Canada/East-Saskatchewan'	=>	'America/Regina',
	'Canada/Eastern'	=>	'America/Toronto',
	'Canada/Mountain'	=>	'America/Edmonton',
	'Canada/Newfoundland'	=>	'America/St_Johns',
	'Canada/Pacific'	=>	'America/Vancouver',
	'Canada/Saskatchewan'	=>	'America/Regina',
	'Canada/Yukon'	=>	'America/Whitehorse',
	'Chile/Continental'	=>	'America/Santiago',
	'Chile/EasterIsland'	=>	'Pacific/Easter',
	'Cuba'	=>	'America/Havana',
	'EAT'	=>	'Africa/Addis_Ababa',
	'ECT'	=>	'Europe/Paris',
	'EST'	=>	'America/Indianapolis',
	'EST5EDT'	=>	'America/New_York',
	'Egypt'	=>	'Africa/Cairo',
	'Eire'	=>	'Europe/Dublin',
	'Etc/GMT+0'	=>	'Etc/GMT',
	'Etc/GMT-0'	=>	'Etc/GMT',
	'Etc/GMT0'	=>	'Etc/GMT',
	'Etc/Greenwich'	=>	'Etc/GMT',
	'Etc/Universal'	=>	'Etc/UTC',
	'Etc/Zulu'	=>	'Etc/UTC',
	'Europe/Nicosia'	=>	'Asia/Nicosia',
	'Europe/Tiraspol'	=>	'Europe/Chisinau',
	'GB'	=>	'Europe/London',
	'GB-Eire'	=>	'Europe/London',
	'GMT'	=>	'Etc/GMT',
	'GMT+0'	=>	'Etc/GMT+0',
	'GMT-0'	=>	'Etc/GMT-0',
	'GMT0'	=>	'Etc/GMT0',
	'Greenwich'	=>	'Etc/Greenwich',
	'HST'	=>	'Pacific/Honolulu',
	'Hongkong'	=>	'Asia/Hong_Kong',
	'IET'	=>	'America/Indianapolis',
	'IST'	=>	'Asia/Calcutta',
	'Iceland'	=>	'Atlantic/Reykjavik',
	'Iran'	=>	'Asia/Tehran',
	'Israel'	=>	'Asia/Jerusalem',
	'JST'	=>	'Asia/Tokyo',
	'Jamaica'	=>	'America/Jamaica',
	'Japan'	=>	'Asia/Tokyo',
	'Kwajalein'	=>	'Pacific/Kwajalein',
	'Libya'	=>	'Africa/Tripoli',
	'MIT'	=>	'Pacific/Apia',
	'MST'	=>	'America/Phoenix',
	'MST7MDT'	=>	'America/Denver',
	'Mexico/BajaNorte'	=>	'America/Tijuana',
	'Mexico/BajaSur'	=>	'America/Mazatlan',
	'Mexico/General'	=>	'America/Mexico_City',
	'Mideast/Riyadh87'	=>	'Asia/Riyadh87',
	'Mideast/Riyadh88'	=>	'Asia/Riyadh88',
	'Mideast/Riyadh89'	=>	'Asia/Riyadh89',
	'NET'	=>	'Asia/Yerevan',
	'NST'	=>	'Pacific/Auckland',
	'NZ'	=>	'Pacific/Auckland',
	'NZ-CHAT'	=>	'Pacific/Chatham',
	'Navajo'	=>	'America/Denver',
	'PLT'	=>	'Asia/Karachi',
	'PNT'	=>	'America/Phoenix',
	'PRC'	=>	'Asia/Shanghai',
	'PRT'	=>	'America/Puerto_Rico',
	'PST'	=>	'America/Los_Angeles',
	'PST8PDT'	=>	'America/Los_Angeles',
	'Pacific/Samoa'	=>	'Pacific/Pago_Pago',
	'Poland'	=>	'Europe/Warsaw',
	'Portugal'	=>	'Europe/Lisbon',
	'ROC'	=>	'Asia/Taipei',
	'ROK'	=>	'Asia/Seoul',
	'SST'	=>	'Pacific/Guadalcanal',
	'Singapore'	=>	'Asia/Singapore',
	'AST4'	=>	'America/Puerto_Rico',
	'AST4ADT'	=>	'America/Halifax',
	'CST6'	=>	'America/Regina',
	'CST6CDT'	=>	'America/Chicago',
	'EST5'	=>	'America/Indianapolis',
	'EST5EDT'	=>	'America/New_York',
	'HST10'	=>	'Pacific/Honolulu',
	'MST7'	=>	'America/Phoenix',
	'MST7MDT'	=>	'America/Denver',
	'PST8'	=>	'Pacific/Pitcairn',
	'PST8PDT'	=>	'America/Los_Angeles',
	'YST9'	=>	'Pacific/Gambier',
	'YST9YDT'	=>	'America/Anchorage',
	'Turkey'	=>	'Europe/Istanbul',
	'UCT'	=>	'Etc/UCT',
	'US/Alaska'	=>	'America/Anchorage',
	'US/Aleutian'	=>	'America/Adak',
	'US/Arizona'	=>	'America/Phoenix',
	'US/Central'	=>	'America/Chicago',
	'US/East-Indiana'	=>	'America/Indianapolis',
	'US/Eastern'	=>	'America/New_York',
	'US/Hawaii'	=>	'Pacific/Honolulu',
	'US/Indiana-Starke'	=>	'America/Indiana/Knox',
	'US/Michigan'	=>	'America/Detroit',
	'US/Mountain'	=>	'America/Denver',
	'US/Pacific'	=>	'America/Los_Angeles',
	'US/Pacific-New'	=>	'America/Los_Angeles',
	'US/Samoa'	=>	'Pacific/Pago_Pago',
	'UTC'	=>	'Etc/UTC',
	'Universal'	=>	'Etc/Universal',
	'VST'	=>	'Asia/Saigon',
	'W-SU'	=>	'Europe/Moscow',
	'Zulu'	=>	'Etc/Zulu',
);
return ($tzname_to_tzid{$tzname}) ? $tzname_to_tzid{$tzname} : ($tzname =~ /^([A-Z]{3}(?!\w))/ && $tzname_to_tzid{$1}) ? $tzname_to_tzid{$1} : $tzname;
}

# ᥤ
sub run ($) {
#no warnings qw(untie);
my $this = shift;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';

#---------------------------------------------------------------------
#񤭽Ф

#ե
my $title_field = ($field::for{'title'}) ? $field::for{'title'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'name'}) ? $field::for{'name'} : "";
my @field = ();
my(%dt);
my %database = ();
my $tzid = '';
foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$o};
	if (
			ref $field::obj{$id}
			&& (
				$id eq $title_field
				|| $field::obj{$id}->{'class'} eq 'xcal_category'
				|| (defined $setting::security{'detail'}{'passwordCheck'} && $setting::security{'detail'}{'passwordCheck'} eq 'nocheck')
				|| $this->is_one_of_owners
			)
			&& !$field::obj{$id}->{'Hidden'}
			&& ($field::obj{$id}->{'Open'} || $this->is_secure('secret'))
		) {
		push(@field,$id);
		my $db = $field::obj{$id}->db;
		if (defined $db && $db && !ref $database{$db} && !ref tied %{$database{$db}}) {
			tie(%{$database{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
		}
	}
}
if (!$database{'mtime'}) {
	tie(%{$database{'mtime'}}, $env::dbm_file, "$default::db/mtime", O_RDONLY, $env::dbm_mode);
}

#HTTPإå
$this->print_http_header('text/i-calendar; charset=utf-8');
print 'BEGIN:VCALENDAR', "\x0D\x0A";
print 'PRODID:-//CMONOS Co. Ltd.//CMONOS.JP//JA', "\x0D\x0A";
print 'METHOD:PUBLISH', "\x0D\x0A";
print 'VERSION:2.0', "\x0D\x0A";
if ($ENV{'TZ'}) {
	$tzid = $this->_tz_to_id($ENV{'TZ'});
	print 'BEGIN:VTIMEZONE', "\x0D\x0A";
	print 'TZID:', $tzid, "\x0D\x0A";
	print 'BEGIN:STANDARD', "\x0D\x0A";
	print 'DTSTART:19390101T000000', "\x0D\x0A";
	if ($ENV{'TZ'} =~ /^([A-Z]{3}(?!\w))([\-+]?\d*)([A-Z]{0,3}(?!\w))([\-+]?\d*)/) {
		my($std,$std_offset,$dst,$dst_offset) = ($1,$2,$3,$4);
		print 'TZOFFSETFROM:', $this->offset_format(($dst_offset) ? $dst_offset : $std_offset), "\x0D\x0A";
		print 'TZOFFSETTO:', $this->offset_format($std_offset), "\x0D\x0A";
	}
	print 'TZNAME:', $ENV{'TZ'}, "\x0D\x0A";
	print 'END:STANDARD', "\x0D\x0A";
	print 'END:VTIMEZONE', "\x0D\x0A";
}
my $domain = $this->to_host($ENV{'SERVER_NAME'});
my $dirid = $this->home_directory(1);
$dirid =~ s!^/!!;
$dirid =~ s/[^\w\-]/\./g;
$dirid .= (($dirid) ? '.' : '') . $default::id;

tie(%dt, $env::dbm_file, $default::db . '/dt', O_RDONLY, $env::dbm_mode);
if (ref tied %dt) {
	EVENT:
	while (my($n,$dt_data) = each %dt) {
		my $category_id;
		if (ref $database{'category'} && %setting::event_category && ref $setting::event_category{'ORDER'} && %{$setting::event_category{'ORDER'}}) {
			$category_id = $database{'category'}->{$n};
			next EVENT if defined $category_id && ref $setting::event_category{$category_id} && $setting::event_category{$category_id}{'closed'} && !$this->is_secure('closed');
		}
		my($dtspan,$rrule) = split(/\x09/,$dt_data);
		my($dtstart,$dtend) = split(/-/,$dtspan);
		my $path = $default::file . '/' . $n;
		my $description = '';
		print 'BEGIN:VEVENT', "\x0D\x0A";
		print 'UID:', $dirid . (($default::subdivided && $main::c) ? '.' . $main::c : '') . '.' . $n . '@' . $domain, "\x0D\x0A";
		print 'DTSTAMP:', $this->time_to_dtstamp($n), "\x0D\x0A";
		print $this->ical_data('SUMMARY:' . $field::obj{$title_field}->format_for_text($database{$field::obj{$title_field}->db}->{$n},$path,$main::c,$n)), "\x0D\x0A" if defined $title_field && $title_field && grep($_ eq $title_field,@field);
		if ((defined $setting::security{'detail'}{'passwordCheck'} && $setting::security{'detail'}{'passwordCheck'} eq 'nocheck') || $this->is_one_of_owners) {
			print $this->ical_data('LOCATION:' . $field::obj{$field::for{'location'}}->format_for_text($database{$field::obj{$field::for{'location'}}->db}->{$n},$path,$main::c,$n)), "\x0D\x0A" if defined $field::for{'location'} && $field::for{'location'} && grep($_ eq $field::for{'location'},@field);
			print $this->ical_data('CONTACT:' . $field::obj{$field::for{'name'}}->format_for_text($database{$field::obj{$field::for{'name'}}->db}->{$n},$path,$main::c,$n)), "\x0D\x0A" if defined $field::for{'name'} && $field::for{'name'} && grep($_ eq $field::for{'name'},@field);
			foreach my $id (@field) {
				next if $id eq $title_field || $id eq $field::for{'location'} || $id eq $field::for{'name'};
				my $db = $field::obj{$id}->db;
				my $data = $field::obj{$id}->format_for_text($database{$db}->{$n},$path,$main::c,$n);
				$data =~ s/\x0A+$//;
				$description .= '[' . $field::obj{$id}->name . "]\x0A" . $data . "\x0A\x0A" if $data =~ /\S/;
			}
			print $this->ical_data('DESCRIPTION:' . $description), "\x0D\x0A" if $description ne '';
		}
		print $this->ical_data('URL;VALUE=URI:' . $this->my_url . '?m=DetailViewer' . (($default::subdivided && $main::c) ? '&c=' . $main::c : '') . '&n=' . $n), "\x0D\x0A";
		print 'DTSTART', (($tzid) ? ';TZID=' . $tzid : ''), (($dtstart =~ /^\d{8}$/) ? ';VALUE=DATE' : ''), ':', $dtstart, "\x0D\x0A";
		print 'DTEND', (($tzid) ? ';TZID=' . $tzid : ''), (($dtend =~ /^\d{8}$/) ? ';VALUE=DATE' : ''), ':', $dtend, "\x0D\x0A";
		print 'RRULE:', $rrule, "\x0D\x0A" if $rrule;
		print $this->ical_data('CATEGORIES:' . ((defined $setting::event_category{$category_id}{'name'} && $setting::event_category{$category_id}{'name'} ne '') ? $setting::event_category{$category_id}{'name'} : $category_id)), "\x0D\x0A" if defined $category_id && ref $setting::event_category{$category_id};
		print 'TRANSP:TRANSPARENT', "\x0D\x0A";
		print 'PRIORITY:0', "\x0D\x0A";
		print 'CLASS:PUBLIC', "\x0D\x0A";
		print 'END:VEVENT', "\x0D\x0A";	
	}
}
untie %dt;
while (my($name,$db) = each %database) {
	untie %$db;
}
print 'END:VCALENDAR';
}

sub offset_format ($$) {
my($this,$offset) = @_;
$offset *= -1;
return (($offset > 0) ? '+' : '') . sprintf("%.2d",$offset) . '00';
}

# =\n
# ,;ϥפɬ=\,\;
sub ical_data ($$) {
my($this,$str) = @_;
$str =~ s/,/\\,/g;
$str =~ s/;/\\;/g;
$str =~ s/^(\w+)\\;/$1;/s;
$str =~ s/[\x0A\x0D]/\\n/g;
$str = $cgi::Jcode->set(\$str)->utf8;
my $ical_data = '';
my $length = 0;
while ($str =~ /\G(\\n|\\,|\\;|[\x00-\x7F]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF][\x80-\xBF])/sg) {
	my $char = $1;
	$length += length $char;
	if ($length > 75) {
		$ical_data .= "\x0D\x0A ";
		$length = 1 + length($char);
	}
	$ical_data .= $char;
}
return $ical_data;
}

######################################################################
# 饹Ͽ
#sub import {
BEGIN {
	#no warnings qw(once);

	#DBɤ߹
	$setting::general = 1;						#ɤ߹
	$setting::deco = 1;						#ƥɤ߹
	$setting::security = 1;					#ɤ߹
	$setting::table = 0;						#ơ֥ɤ߹
	$setting::page = 0;						#ڡɤ߹

	$setting::field_db_name = 'inputfield';	#եDB
	$setting::field = 2;						#եɤ߹ߡ2=ꥸʥɤ߹
	$setting::field_style_disabled = 0;			#2=եꥹ̵/1=եΤ̵
	$setting::field_tag_enabled = 'no';				#tag=Τ/all=Ƥ/no=Ĥʤ

	#省
	$setting::security_key = 'browse';							#ǥեȥƥ
	$setting::key = 'none';						#ڡꥭ

	#å
	$cookie::id_enabled = 1;							#ID󥯥åɤ߹

	#ǥեȥ
	$main::k = 'ics';

	#饹Ͽ
	Common::class_register('ics','Ics');

}

1;
