/**

grelatedpages.js 1.0
Copyright 2008 CMONOS Co.Ltd.
License: MIT License 

URI: http://cmonos.jp/
Last Modified: 2008-12-01
Author: CMONOS Co.Ltd.

【使い方の例】
関連ページを表示したい位置で JavaScript を読み込みます。
<script src="http://www.google.com/jsapi?key=APIKEY" type="text/javascript"></script>
<script language="Javascript" type="text/javascript" src="grelatedpages.js" charset="UTF-8"></script>
<script language="Javascript" type="text/javascript">
//<![CDATA[
writeGRelatedPages(
	'target-id',	// 関連ページ一覧を表示するブロックの id
	'keywords',		// 関連ページを検索するためのキーワード(" | " で区切る) ＜ここまで必須
	'here',			// 設置ページのURL
	'linkTarget',	// ターゲットウィンドウ(self|blank)
	'resultSet',	// 結果の数(small=4|large=8)
	[				// タブの設定。
		{
			'label'			: 'タブのタイトル',
			'site'			: 'サイトドメイン',
			'inurl'			: '検索対象 URL',
			'exurl'			: ['検索対象から除外する URL',...],
		}
	]
);
//]]>
</script>

【CSS のヒント】

↓幅を上位ブロックにあわせる
.gsc-control {
  width: 100%;
}

↓検索欄を消す
.gsc-input, .gsc-search-button, .gsc-clear-button {
  display: none;
}

*/

//	【パラメータ】
var gsearch_api_key;

if (typeof google == 'undefined') document.write('<script src="http://www.google.com/jsapi' + ((gsearch_api_key != "") ? '?key=' + gsearch_api_key : '') + '" type="text/javascript"></script>');

function writeGRelatedPages (target_id,keywords,here,link_target,result_set,this_tab) {
	if (typeof here == 'undefined' || here == null) here = document.location.href.replace(/#.*?$/,'').replace(/^https?:\/\//i,'');
	if (typeof this_tab == 'undefined' || this_tab == null) {
		this_tab = [
			{
				'label'	:	'このサイト',
				'site'	:	document.domain
			},
			{
				'label'	:	'Web'
			}
		];
	}
	if (typeof google == 'undefined' || google == null) {
		return true;
	} else if (typeof google.search == 'undefined' || google.search == null) {
		google.load("search", "1");
	}
	google.setOnLoadCallback(function () { _writeGRelatedPages(target_id,keywords,here,link_target,result_set,this_tab) });
}

function _writeGRelatedPages(target_id,keywords,here,link_target,result_set,this_tab) {
	var searchControl = new google.search.SearchControl();
	searchControl.setLinkTarget((link_target != null && link_target == 'blank') ? google.search.Search.LINK_TARGET_BLANK : google.search.Search.LINK_TARGET_SELF);
	searchControl.setResultSetSize((result_set != null && result_set == 'large') ? google.search.Search.LARGE_RESULTSET : google.search.Search.SMALL_RESULTSET);
	var options = new GsearcherOptions();
	options.setExpandMode(GSearchControl.EXPAND_MODE_OPEN);
	for (var i=0; i < this_tab.length; i++) {
		var searcher = new GwebSearch();
		if (this_tab[i].site != null) searcher.setSiteRestriction(this_tab[i].site);
		var query = '';
		if (this_tab[i].inurl != null) query += ((query != '') ? ' ' : '') + 'inurl:' + this_tab[i].inurl;
		if (here != null) query += ((query != '') ? ' ' : '') + '-inurl:' + here;
		if (this_tab[i].exurl != null) {
			for (var j=0; j < this_tab[i].exurl.length; j++) {
				if (this_tab[i].exurl[j] != null) query += ((query != '') ? ' ' : '') + '-inurl:' + this_tab[i].exurl[j];
			}
		}
		searcher.setQueryAddition(query);
		searcher.setUserDefinedLabel(this_tab[i].label);
		searchControl.addSearcher(searcher,options);
	}
	searchControl.setNoResultsString(google.search.SearchControl.NO_RESULTS_DEFAULT_STRING);
	var drawOptions = new GdrawOptions();
	drawOptions.setDrawMode(GSearchControl.DRAW_MODE_TABBED);
	searchControl.draw(document.getElementById(target_id), drawOptions);
	searchControl.execute(keywords);
}

